Loading...
Searching...
No Matches
Dune::TypeTree::Experimental::Info Namespace Reference
dune-typetree » Traversal

## Classes

struct | LeafCounterVisitor
struct | NodeCounterVisitor
struct | DepthVisitor

## Functions

template<typename Tree>
auto | depth (const Tree &tree)
| The depth of the TypeTree.
template<typename Tree>
constexpr auto | depth ()
| The depth of the Tree.
template<typename Tree>
auto | nodeCount (const Tree &tree)
| The total number of nodes in the Tree.
template<typename Tree>
auto | leafCount (const Tree &tree)
| The number of leaf nodes in the Tree.

## Variables

template<typename Tree>
constexpr bool | isDynamic = std::is_same<std::size_t, decltype(leafCount(std::declval<Tree>()))>{}
| true if any of the nodes in the tree only has dynamic degree.

## Function Documentation

## depth() [1/2]

template<typename Tree>

auto Dune::TypeTree::Experimental::Info::depth | ( |  | ) |

constexpr

The depth of the Tree.

## depth() [2/2]

template<typename Tree>

auto Dune::TypeTree::Experimental::Info::depth | ( | const Tree & | tree | ) |

The depth of the TypeTree.

## leafCount()

template<typename Tree>

auto Dune::TypeTree::Experimental::Info::leafCount | ( | const Tree & | tree | ) |

The number of leaf nodes in the Tree.

## nodeCount()

template<typename Tree>

auto Dune::TypeTree::Experimental::Info::nodeCount | ( | const Tree & | tree | ) |

The total number of nodes in the Tree.

## Variable Documentation

## isDynamic

template<typename Tree>

bool Dune::TypeTree::Experimental::Info::isDynamic = std::is_same<std::size_t, decltype(leafCount(std::declval<Tree>()))>{}

constexpr

true if any of the nodes in the tree only has dynamic degree.